Description

During installation/upgrade of foreman/katello, the file:

/usr/share/foreman-installer/modules/qpid/manifests/service.pp

Writes out the erb template found at:

/usr/share/foreman-installer/modules/qpid/templates/wait-for-port.conf.erb

To the location:

/etc/systemd/system/qpidd.service.d/wait-for-port.conf

This file causes the startup script for qpidd to wait for the port to show as open before marking the service as started by using ncat's

-z switch using the command:

ExecStartPost=/bin/bash -c 'while ! nc -z 127.0.0.1 <%= scope['qpid::ssl_port'] %>; do sleep 1; done'

The issue however is that the "-z" switch has been deprecated in (at least) version 6.47 of ncat. Thus, another way to achieve this

objective is needed. While this is not an issue for a default CentOS/RHEL 7 installation, the problem will presumably arise with

RHEL/CentOS 8 and will show up for any who use the atomic repo.

To reproduce: 

Configure the Atomic repo as a source for yum: https://wiki.atomicorp.com/wiki/index.php/Atomic

Run yum -y update nmap-ncat

Attempt to restart qpidd or perform an upgrade or install of foreman

Related issues:

Related to Installer - Bug #30252: error Error reading socket: Encountered en... Closed

History

#1 - 11/05/2019 06:14 PM - James Shewey

- Priority changed from Normal to Low

Looking at CentOS 8 with version 7.70 of ncat, the -z switch is available as "Zero-I/O mode, report connection status only" according to the manual,

so this looks to be a problem only for those with Atomic configured.

#2 - 11/05/2019 09:14 PM - Ewoud Kohl van Wijngaarden

- Category set to Foreman modules

It looks like nc actually comes from nmap-ncat in Fedora. Perhaps this is available in Atomic?

#3 - 02/17/2020 09:16 AM - Kamil Maslowski

It can be easily fixed with:
ExecStartPost=/bin/bash -c 'while ! nc -w 1 127.0.0.1 <%= scope['qpid::ssl_port'] %> </dev/null; do sleep 1; d

one'

#4 - 02/20/2020 07:57 PM - Ewoud Kohl van Wijngaarden

The source is at https://github.com/theforeman/puppet-qpid/blob/master/templates/wait-for-port.conf.erb and a patch is highly welcome.

#5 - 11/17/2020 06:06 PM - Eric Helms

- Status changed from New to Resolved

#6 - 11/17/2020 06:06 PM - Eric Helms

- Related to Bug #30252: error Error reading socket: Encountered end of file [-5938] when starting qpidd service added
